#include <iostream>
#include <unistd.h>
using namespace std;


template <class D> class container {
    public:
        container *proximo;
        D elemento;
};


template <class T, class Container=container<T>>
class Fila {
    public:
        void enfilera(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;

            if (fim != nullptr)
                fim->proximo = cont;
                
            else 
                inicio = cont;
            
            fim = cont;
        }


        T desenfilera() {
            if (inicio != nullptr) {
                T elemento = inicio->elemento;
                Container *i = inicio;
                inicio = inicio->proximo;
                if (inicio == nullptr)
                    fim = nullptr;
                delete i;
                return elemento;
            }
            else
                return -1;
        }

        T frente() {
            if (inicio != nullptr)
                return inicio->elemento;
            else
                return -1;
        }
        
    private:
        Container *inicio = nullptr;
        Container *fim = nullptr;

};


template <class T>
class Pilha { 

    public:
        void empilha(T elemento) {
            if (fila == nullptr)
                fila = new Fila<T>();

            fila->enfilera(elemento);
        }
        T desempilha() {

            if (fila->frente() == -1)
                return -1;
            auto filaAux = new Fila<T>();
            T elemento;
            while (fila->frente() != -1) {
                elemento = fila->desenfilera();
                if (fila->frente() != -1)
                    filaAux->enfilera(elemento);
            }
            delete fila;
            fila = filaAux;
            return elemento;

        }
    private:

        Fila<T> *fila = new Fila<T>();

};



int main(int argc, char* argv[]) {

    Pilha<int> mpilha;
    mpilha.empilha(2);
    mpilha.empilha(32);
    mpilha.empilha(54);
    mpilha.empilha(96);
    mpilha.empilha(11);
    mpilha.empilha(78);

    int e = mpilha.desempilha();
    while (e != -1) {
        cout << "elem: " << e <<endl;
        e = mpilha.desempilha();
    }

    return 0;

}