#include <iostream>

template <class D> class container {
    public:
        container *proximo;
        D elemento;
};


template <class T, class Container=container<T>>
class Fila {
    public:
        void enfilera(T elem) {
            auto cont = new container<T>();
            cont->elemento = elem;

            if (fim != nullptr)
                fim->proximo = cont;
                
            else 
                inicio = cont;
            
            fim = cont;
        }


        T desenfilera() {
            if (inicio != nullptr) {
                T elemento = inicio->elemento;
                Container *i = inicio;
                inicio = inicio->proximo;
                if (inicio == nullptr)
                    fim = nullptr;
                delete i;
                return elemento;
            }
            else
                return -1;
        }

        T frente() {
            if (inicio != nullptr)
                return inicio->elemento;
            else
                return -1;
        }
        
    private:
        Container *inicio = nullptr;
        Container *fim = nullptr;

};

template <class T>
class Pilha { 

    public:
        void empilha(T elemento) {
            N++;
            elementos[N -1] = elemento;

        }
        T desempilha() {
            if (N > 0) {
                N--;
                return elementos[N];
            }
            else
                return -1;
        }

        T topo() {
            if (N > 0)
                return elementos[N -1];
            else   
                return -1;
        }
    private:
        static const int MAX = 900;
        int N = 0;
        T elementos[MAX];

};

template <class T> Pilha<T> inverterPilha(Pilha<T> pilha) {

    Pilha<T> pilhaAux;
    while (pilha.topo() != -1) {
        pilhaAux.empilha(pilha.desempilha());
    }

    return pilhaAux;
}

template <class T> Pilha<T> inverterPilhaComFila(Pilha<T> pilha) {

    Fila<T> filaAux;
    while (pilha.topo() != -1) {
        filaAux.enfilera(pilha.desempilha());
    }

    while (filaAux.frente() != -1) {
        pilha.empilha(filaAux.desenfilera());
    }


    return pilha;
}

template <class T> Pilha<T> inverterPilhaComDuasPilhas(Pilha<T> pilha) {

    Pilha<T> pilhaAux, pilhaAux2;
    while (pilha.topo() != -1) {
        pilhaAux.empilha(pilha.desempilha());
    }
    while (pilhaAux.topo() != -1) {
        pilhaAux2.empilha(pilhaAux.desempilha());
    }
    while (pilhaAux2.topo() != -1) {
        pilhaAux.empilha(pilhaAux2.desempilha());
    }

    return pilhaAux;
}

void preencherPilha(Pilha<char> &pilha) {

    pilha.empilha('a');
    pilha.empilha('b');
    pilha.empilha('c');
    pilha.empilha('d');
    pilha.empilha('e');
    pilha.empilha('f');
    pilha.empilha('g');
    pilha.empilha('h');
    pilha.empilha('i');
    pilha.empilha('j');
    pilha.empilha('k');
    pilha.empilha('l');
    pilha.empilha('m');
    pilha.empilha('n');
    pilha.empilha('o');
    pilha.empilha('p');
    pilha.empilha('q');
    pilha.empilha('r');
    pilha.empilha('s');
    pilha.empilha('t');
    pilha.empilha('u');
    pilha.empilha('v');
    pilha.empilha('w');
    pilha.empilha('x');
    pilha.empilha('y');
    pilha.empilha('z');
}

void printarPilha(Pilha<char> &pilha, std::string texto) {

    std::cout << "----" << texto << "------" << std::endl;
    while (pilha.topo() != -1) {
        std::cout << "| " << pilha.desempilha() << " " ;
    }
    std::cout << "|" << std::endl;
}

int main(int argc, char* argv[]) {

    Pilha<char> pilha;
    preencherPilha(pilha);
    printarPilha(pilha, "Pilha normal");

    

    preencherPilha(pilha);
    pilha = inverterPilha(pilha);
    printarPilha(pilha, "Pilha invertida com pilha");

    preencherPilha(pilha);
    pilha = inverterPilhaComFila(pilha);
    printarPilha(pilha, "Pilha invertida com FILA");

    preencherPilha(pilha);
    pilha = inverterPilhaComDuasPilhas(pilha);
    printarPilha(pilha, "Pilha invertida com duas Pilhas");
    

    
    return 0;
}